@use 'variables' as *;
@use 'functions' as *;

// Media of at least the minimum breakpoint width. No query for the smallest breakpoint.
// Makes the @content apply to the given breakpoint and wider.
@mixin media-breakpoint-up($name, $breakpoints: $grid-breakpoints) {
  $min: breakpoint-min($name, $breakpoints);
  @if $min {
    @media (min-width: $min) {
      @content;
    }
  } @else {
    @content;
  }
}



// Utility generator (from Vuetify)
// Used to generate utilities & print utilities
// @mixin generate-utility($utility, $infix, $forceDir) {
//   $values: map-get($utility, values);

//   // If the values are a list or string, convert it into a map
//   @if type-of($values) == "string" or type-of(nth($values, 1)) != "list" {
//     $values: zip($values, $values);
//   }

//   @each $key, $value in $values {
//     $properties: map-get($utility, property);

//     // Multiple properties are possible, for example with vertical or horizontal margins or paddings
//     @if type-of($properties) == "string" {
//       $properties: append((), $properties);
//     }


//     // Property can be a map, where the key is a mixin to include
//     @if type-of($properties) == 'map' {
//       @each $dir in $properties {
//         $mixin: nth($dir, 1);
//         // SASS doesn't support dynamic mixin invocation
//         // https://github.com/sass/sass/issues/626
//         @if $mixin == 'ltr' {
//           //.v-application--is-ltr {
//             @include generate-utility-body($utility, nth($dir, 2), $value, $infix);
//           //}
//         } @else if $mixin == 'rtl' {
//           //.v-application--is-rtl
//             @include generate-utility-body($utility, nth($dir, 2), $value, $infix);
//         } @else {
//           @error 'Only RTL and LTR are supported'
//         }
//       }
//     } @else {
//       @if $forceDir == 'ltr' {
//           @include generate-utility-body($utility, $properties, $value, $infix)
//       } @else if $forceDir == 'rtl' {
//           @include generate-utility-body($utility, $properties, $value, $infix)
//       } @else {
//           @include generate-utility-body($utility, $properties, $value, $infix)
//       }
//     }
//   }
// }



@mixin generate-utility-body($utility, $properties, $value, $infix) {
  // Use custom class if present
  $property-class: map-get($utility, class);
  $property-class: if($property-class, $property-class, nth($properties, 1));

  // Don't prefix if value key is null (eg. with shadow class)
  $property-class-modifier: if(nth($value, 1), "-" + nth($value, 1), "");

  $value: nth($value, 2);

  .#{$property-class + $infix + $property-class-modifier} {
    @for $i from 1 through length($properties) {
      $property: nth($properties, $i);
      $val: $value;
      @if type-of($value) == 'list' and length($properties) == length($value) {
        $val: nth($value, $i);
      }
      @if $val != false {
        // Check if unimportant property exists.
        // This allows you to conditional skip
        // defining a property as important.
        $unimportant: map-get($utility, unimportant);
        #{$property}: $val if(index($unimportant, $property), null, !important);
      }
    }
  }
}







// Utility generator
// Used to generate utilities & print utilities
@mixin generate-utility($utility, $infix, $is-rfs-media-query: false) {
  $values: map-get($utility, values);

// If the values are a list or string, convert it into a map
  @if type-of($values) == "string" or type-of(nth($values, 1)) != "list" {
  $values: zip($values, $values);
}

@each $key, $value in $values {
  $properties: map-get($utility, property);

// Multiple properties are possible, for example with vertical or horizontal margins or paddings
                                         @if type-of($properties) == "string" {
  $properties: append((), $properties);
}

// Use custom class if present
$property-class: if(map-has-key($utility, class), map-get($utility, class), nth($properties, 1));
$property-class: if($property-class == null, "", $property-class);

// Use custom CSS variable name if present, otherwise default to `class`
                                                      $css-variable-name: if(map-has-key($utility, css-variable-name), map-get($utility, css-variable-name), map-get($utility, class));

// State params to generate pseudo-classes
$state: if(map-has-key($utility, state), map-get($utility, state), ());

$infix: if($property-class == "" and str-slice($infix, 1, 1) == "-", str-slice($infix, 2), $infix);

// Don't prefix if value key is null (eg. with shadow class)
    $property-class-modifier: if($key, if($property-class == "" and $infix == "", "", "-") + $key, "");

    @if map-get($utility, rfs) {
// Inside the media query
      @if $is-rfs-media-query {
        $val: rfs-value($value);

// Do not render anything if fluid and non fluid values are the same
        $value: if($val == rfs-fluid-value($value), null, $val);
      }
      @else {
        $value: rfs-fluid-value($value);
      }
    }

    $is-css-var: map-get($utility, css-var);
    $is-local-vars: map-get($utility, local-vars);
    $is-rtl: map-get($utility, rtl);

    @if $value != null {
      @if $is-rtl == false {
        /* rtl:begin:remove */
      }

      @if $is-css-var {
        .#{$property-class + $infix + $property-class-modifier} {
          --#{$prefix}#{$css-variable-name}: #{$value};
        }

        @each $pseudo in $state {
          .#{$property-class + $infix + $property-class-modifier}-#{$pseudo}:#{$pseudo} {
            --#{$prefix}#{$css-variable-name}: #{$value};
          }
        }
      } @else {
        .#{$property-class + $infix + $property-class-modifier} {
          @each $property in $properties {
            @if $is-local-vars {
              @each $local-var, $variable in $is-local-vars {
                --#{$prefix}#{$local-var}: #{$variable};
              }
            }
            #{$property}: $value if($enable-important-utilities, !important, null);
          }
        }

        @each $pseudo in $state {
          .#{$property-class + $infix + $property-class-modifier}-#{$pseudo}:#{$pseudo} {
            @each $property in $properties {
              #{$property}: $value if($enable-important-utilities, !important, null);
            }
          }
        }
      }

      @if $is-rtl == false {
        /* rtl:end:remove */
      }
    }
  }
}
